var enable_debug_mode = false;

var appEnvironment = angular.module('app', ['onsen.directives']);
document.addEventListener("deviceready", onDeviceReady, false);
appEnvironment.service('hexafy', function () {
    this.myFunc = function (x) {
        return x.toString(16);
    }
});

function onDeviceReady() {
    angular.element(document.body).scope().AppInit();
    if (window.WinJS && window.WinJS.Application) {
        window.WinJS.Application.onbackclick = function () {
            if (window.location.hash === '#/') {
                return false;
            }

            window.history.back();
            return true;
        };
    }

}


angular.module('app').controller('AppController', function ($scope) {

    $scope.settings_scoresToWin = 5;
    $scope.playerList = [];
    $scope.FontOptions = [
        { value: "1", label: "Fun" },
        { value: "2", label: "Intense" },
        { value: "3", label: "Free Hand" },
        { value: "4", label: "Simple" }
    ];
    FontOptions = {
        Fun: 1,
        Intense: 2,
        FreeHand: 3,
        Simple: 4
    }
    $scope.settings_fontChooser = String(FontOptions.Fun);
    $scope.AppLanguage = LANGUAGE.ENGLISH;
    $scope.LanguageOptions = [
        { value: "1", label: "English" },
        { value: "2", label: "German" },
        { value: "3", label: "Spanish" },
        { value: "4", label: "Chinese - Traditional" },
        { value: "5", label: "Chinese - Simplified" }
    ];
    $scope.settings_languageChooser = String(LANGUAGE.ENGLISH);
    $scope.AppLanguage = LANGUAGE.ENGLISH;
    $scope.translations = {};
    $scope.MessageArchive = [];
    $scope.deckNeverHaveIEver = [];
    $scope.deckPointer = -1;
    $scope.scoring = [];
    $scope.newPlayerImg;
    $scope.GameLengthOptions = [
        { value: "3", label: "Very Short" },
        { value: "5", label: "Short" },
        { value: "10", label: "Standard" },
        { value: "20", label: "Long" }
    ];
    GameLengthOptions = {
        VERYSHORT: 3,
        SHORT: 5,
        STANDARD: 10,
        LONG: 20
    }
    $scope.GameLength = String(GameLengthOptions.STANDARD);
    $scope.game_status = "active";
    $scope.userWarning_noimage = false;
    $scope.playerAwards = [];
    $scope.watermark;
    $scope.canvasDom;
    $scope.canvas;
    $scope.htmlCanvas;
    var NHIEAttributes = {
        Sexy: 1,
        Illegal: 2,
        Nerdy: 3,
        Dangerous: 4,
        Gross: 5,
        Adventurous: 6,
        Embarrassing: 7,
        Smooth: 8,
        Celebrity: 9,
        TroubledYouth: 10,
        Lucky: 11
    }
    $scope.showAwards = false;
    $scope.editPlayerIndex = -1;
    $scope.awardsToMake = [];
    $scope.playersAwarded = [];


    // INIT
    $scope.AppInit = function () {

        LoadDigimoServices("Never Have I Ever",
            "1.1.12",
            enable_debug_mode,
            "fUIVKyT0vvN",
            "UA-60035493-5",
            "com.digimo.neverhaveiever",
            "",
            "",
            "https://play.google.com/store/apps/details?id=com.digimo.neverhaveiever",
            "",
            "http://apps.digitsinmotion.com/never-have-i-ever/pick-platform",
            true,
            "1044189801653",
            "neverhaveiever",
             null);

        $scope.LoadSettings();

        $scope.$apply($scope.BuildTranslations());
        $scope.ShuffleNHIEs();
        navigator.splashscreen.hide();
    }


    $scope.PullLatestNHIEs = function () {
        // THIS NEEDS TO BE PROGRAMMED

        //BEGIN AJAX TO GET LATEST STAR CARD
        var request;
        if (request) {
            request.abort();
        }

        var formData = { "key": thisVersionKey, "platform": device_platform, "appversion": thisAppVersion, "currentkey": activestarcard_key };
        request = $.ajax
        ({
            url: "http://etc.digitsinmotion.com/circlestarcards.php",
            type: "post",
            data: formData,
            dataType: 'json',
            success: $scope.handleStarCardResponse
        });

        request.done(function (response, textStatus, jqXHR) {
        });

        request.fail(function (jqXHR, textStatus, errorThrown) {
            analyticsTrackEvent("Error", "Star Card Retrieval Failure", errorThrown);

        });

        request.always(function () {
        });
    }
    $scope.BuildTranslations = function () {
        switch ($scope.AppLanguage) {
            case LANGUAGE.SPANISH:
                $scope.translations['card-text'] = decodeHTML("Never Have I Ever, Ese");
                break;
            default:
                $scope.translations['app-title'] = "Never Have I Ever";
                $scope.translations['card-text'] = "Never Have I Ever";
                $scope.translations['game-settings'] = "Game Settings";
                $scope.translations['settings-language'] = "Language";
                $scope.translations['settings-font'] = "Game Font";
                $scope.translations['digimo-games'] = "Digimo Games";
                $scope.translations['settings-news'] = "App News and Updates";
                $scope.translations['settings-how-to-play'] = "How to Play";
                $scope.translations['settings-rate-this-game'] = "Rate This Game";
                $scope.translations['settings-more-party-games'] = "More Party Games";
                $scope.translations['settings-unlock-new-features'] = "Unlock New Features";
                $scope.translations['settings-send-game-to-a-friend'] = "Send Game to a Friend";
                $scope.translations['settings-send-us-a-message'] = "Contact Us";
                $scope.translations['back-button'] = "Back";
                $scope.translations['cancel'] = "Cancel";
                $scope.translations['screen-title-add-player'] = "Add Player";
                $scope.translations['add-player'] = "Add Player";
                $scope.translations['edit-player'] = "Edit Player";
                $scope.translations['add-player-instructions']="Add a name and picture for each player. Pictures are optional, but make the game more fun.";
                $scope.translations['game-over'] = "Game Over";
                $scope.translations['rate-game'] = "Rate Game";
                $scope.translations['play-again'] = "Play Again";
                $scope.translations['previous'] = "Previous";
                $scope.translations['next'] = "Next";
                $scope.translations['start-game'] = "Start Game";
                $scope.translations['take-picture'] = "Take Your Picture";
                $scope.translations['retake-picture'] = "Retake Picture";
                $scope.translations['awards-info'] = "Based on your responses...";
                $scope.translations['settings-title'] = "Settings";
                $scope.translations['settings-start-over'] = "Start Over";
                $scope.translations['settings-game-length'] = "Game Length";
                $scope.translations['help-and-promotions'] = "Help and Promotions";
                $scope.translations['start-over-question'] = "Start Over?";
                $scope.translations['confirm-start-over'] = "Are you sure you want to start over? All game progress will be reset.";
                $scope.translations['yes'] = "Yes";
                $scope.translations['no'] = "No";
                $scope.translations['contact-us'] = "Contact Us";
                $scope.translations['send'] = "Send";
                $scope.translations['how-to-play'] = "Gather some friends together for play Never Have I Ever. \n\nTo start, add all players using the button above. Then click Start Game. \n\nRead each statement of the game as \"Never Have I Ever ... \". \n\nEach player that has done the statement takes a drink, marks themself in the game and tells the story of what happened.";
                $scope.translations['remove'] = "Remove";
                $scope.translations['confirm-message-remove-player'] = "Are you sure you want to remove this player from the game?";
                $scope.translations['remove-player'] = "Remove Player";
                $scope.translations['shareapp-longdesc'] = "Never Have I Ever is a free app to play at parties or bars that brings up hilarious stories from your friends.";
                $scope.translations['shareapp-shortdesc'] = "Check out this mobile app version of Never Have I Ever";
                $scope.translations['sharetounlock-desc'] = "I'm playing the party game Never Have I Ever on my phone with friends.";




                //// Language Specific NHIEs

                // No Attributes
                $scope.deckNeverHaveIEver.push({ body: "Fake an Orgasm", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Blacked Out", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Ridden in an Ambulance", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Jumped in a Pool with my Clothes On", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Donated Blood", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Had Braces", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Fallen Asleep at the Movies", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Shaved my Head", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Had Surgery", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Seen Someone Die", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Boycotted Something", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Broken off an Engagement", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Given Someone a Fake Number", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Smoked a Cigar", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Slept on the Job", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Pretended to Speak Another Language", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Opened Someone Else's Mail", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Killed an Animal", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Been on a Court Jury", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Been Married", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Gotten a Divorce", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Gotten Plastic Surgery", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Tried Witchcraft", attributes: [] });
                $scope.deckNeverHaveIEver.push({ body: "Dyed My Hair", attributes: [] });

                // NERDY
                $scope.deckNeverHaveIEver.push({ body: "Written Fan Fiction", attributes: [NHIEAttributes.Nerdy] });
                $scope.deckNeverHaveIEver.push({ body: "Read Lord of the Rings", attributes: [NHIEAttributes.Nerdy] });
                $scope.deckNeverHaveIEver.push({ body: "Read a Harry Potter Book", attributes: [NHIEAttributes.Nerdy] });
                $scope.deckNeverHaveIEver.push({ body: "Made Up a Boyfriend or Girlfriend", attributes: [NHIEAttributes.Nerdy] });

                // SMOOTH
                $scope.deckNeverHaveIEver.push({ body: "Talked My Way Out of a Ticket", attributes: [NHIEAttributes.Smooth] });
                $scope.deckNeverHaveIEver.push({ body: "Lied on a Job Application", attributes: [NHIEAttributes.Smooth] });

                // SMOOTH AND TROUBLED YOUTH
                $scope.deckNeverHaveIEver.push({ body: "Snuck into a Movie Without Paying", attributes: [NHIEAttributes.Illegal, NHIEAttributes.Smooth] });
                $scope.deckNeverHaveIEver.push({ body: "Used a Fake ID", attributes: [NHIEAttributes.Illegal, NHIEAttributes.Smooth, NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Drank Underage", attributes: [NHIEAttributes.Illegal, NHIEAttributes.TroubledYouth] });

                // ILLEGAL
                $scope.deckNeverHaveIEver.push({ body: "Smoked Weed", attributes: [NHIEAttributes.Illegal] });
                $scope.deckNeverHaveIEver.push({ body: "Committed a Felony", attributes: [NHIEAttributes.Illegal] });
                $scope.deckNeverHaveIEver.push({ body: "Stolen Alcohol", attributes: [NHIEAttributes.Illegal] });
                $scope.deckNeverHaveIEver.push({ body: "Been Arrested", attributes: [NHIEAttributes.Illegal] });
                $scope.deckNeverHaveIEver.push({ body: "Written Graffiti", attributes: [NHIEAttributes.Illegal] });
                $scope.deckNeverHaveIEver.push({ body: "Shoplifted", attributes: [NHIEAttributes.Illegal] });
                $scope.deckNeverHaveIEver.push({ body: "Been Chased by the Cops", attributes: [NHIEAttributes.Illegal] });

                // DANGEROUS AND ILLEGAL
                $scope.deckNeverHaveIEver.push({ body: "Shot Someone", attributes: [NHIEAttributes.Illegal, NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Bought Illegal Drugs", attributes: [NHIEAttributes.Illegal, NHIEAttributes.Dangerous] });

                // DANGEROUS
                $scope.deckNeverHaveIEver.push({ body: "Been at Fault in a Car Accident", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Totalled a Car", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Broke a Bone", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Been Bitten By A Snake", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Pointed a Gun at Someone", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Touched an Electric Fence", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Been in a Bar Fight", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Been Mugged", attributes: [NHIEAttributes.Dangerous] });
                $scope.deckNeverHaveIEver.push({ body: "Witnessed a Major Crime", attributes: [NHIEAttributes.Dangerous] });

                // DANGEROUS AND ADVENTUROUS
                $scope.deckNeverHaveIEver.push({ body: "Been Sky Diving", attributes: [NHIEAttributes.Dangerous, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Been Bungee Jumping", attributes: [NHIEAttributes.Dangerous, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Rode a Motorcycle", attributes: [NHIEAttributes.Dangerous, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Jumped Off A Cliff", attributes: [NHIEAttributes.Dangerous, NHIEAttributes.Adventurous] });

                // LUCKY AND ADVENTUROUS
                $scope.deckNeverHaveIEver.push({ body: "Ridden in a Hot Air Balloon", attributes: [NHIEAttributes.Adventurous, NHIEAttributes.Lucky] });

                // ADVENTUROUS
                $scope.deckNeverHaveIEver.push({ body: "Been to a Gay Bar", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Gotten a Tattoo", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Eaten Alligator Meat", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Ridden in a Helicopter", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Eaten a Snake", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Ridden a Mechanical Bull", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Shot a Gun", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Been Part of a Picket Line", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Bet More Than $100 in a Single Hand", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Performed on a Stage", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Been to the Middle East", attributes: [NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Traveled to Another Continent", attributes: [NHIEAttributes.Adventurous] });

                // SEXY AND ADVENTUROUS
                $scope.deckNeverHaveIEver.push({ body: "Had Sex On The Beach", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Made a Sex Tape", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex on an Airplane", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Gone Skinny Dipping", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Gone Streaking", attributes: [NHIEAttributes.Adventurous, NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Anal Sex", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Adventurous] });
                $scope.deckNeverHaveIEver.push({ body: "Sunbathed Naked", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Adventurous] });

                // SEXY
                $scope.deckNeverHaveIEver.push({ body: "Played Strip Poker", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Played Spin the Bottle", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex in a Car", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Taken Nude Photos of Myself", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Masterbated with a Fruit or Vegetable", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Taken Nude Photos of Someone Else", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex in the Kitchen", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex Outdoors", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex in My Parents' Bed", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex while Handcuffed", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex in a Park", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Been Whipped During Sex", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Done a Body Shot", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Paid for Sex", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex with Someone of a Different Race", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Phone Sex", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Talked About Sex with my Mother", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Shaved My Pubes", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Gotten a Lap Dance", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Kissed a Co-Worker", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex at Work", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Watched Porn with Someone Else", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex with a Roommate", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex in Front of Others", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Taken Someone's Virginity", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Used a Sex Toy on Someone", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Masterbated at Someone Else's House", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Masterbated at Work", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Masterbated at School", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex with a Ginger", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Sent Naked Pictures to a Stranger", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Slept with Someone 10 Years Older", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Slept with Someone 10 Years Younger", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Been Naked in Front of 10 or More People", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex in the Snow", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Been to a Strip Club", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Worn The Opposite Sex's Underwear", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Read 50 Shades of Gray", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Kissed a Stripper", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Flashed Someone", attributes: [NHIEAttributes.Sexy] });
                $scope.deckNeverHaveIEver.push({ body: "Had Sex on a Toilet", attributes: [NHIEAttributes.Sexy] });

                // TROUBLED YOUTH AND SEXY
                $scope.deckNeverHaveIEver.push({ body: "Been Caught Hooking Up By My Parents", attributes: [NHIEAttributes.Sexy, NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Hooked Up with my Teacher", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth, NHIEAttributes.TroubledYouth] });

                // SMOOTH AND SEXY
                $scope.deckNeverHaveIEver.push({ body: "Kissed Someone on the First Date", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth] });
                $scope.deckNeverHaveIEver.push({ body: "Slept with my Masseuse", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth] });
                $scope.deckNeverHaveIEver.push({ body: "Slept with my Hair Dresser", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth] });
                $scope.deckNeverHaveIEver.push({ body: "Had a Threesome", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth, NHIEAttributes.Lucky] });
                $scope.deckNeverHaveIEver.push({ body: "Slept with my Waiter or Waitress", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth] });
                $scope.deckNeverHaveIEver.push({ body: "Had Multiple Partners in One Night", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth] });
                $scope.deckNeverHaveIEver.push({ body: "Kissed a Complete Stranger", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Smooth] });

                // GROSS AND SEXY
                $scope.deckNeverHaveIEver.push({ body: "Given a Rim Job", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Gross] });
                $scope.deckNeverHaveIEver.push({ body: "Slept with Someone I Thought Was Ugly", attributes: [NHIEAttributes.Sexy, NHIEAttributes.Gross] });

                // GROSS
                $scope.deckNeverHaveIEver.push({ body: "Thrown Up at a Club", attributes: [NHIEAttributes.Gross] });
                $scope.deckNeverHaveIEver.push({ body: "Eaten Dog Meat", attributes: [NHIEAttributes.Gross] });
                $scope.deckNeverHaveIEver.push({ body: "Farted While Hooking Up", attributes: [NHIEAttributes.Gross] });
                $scope.deckNeverHaveIEver.push({ body: "Taken a Selfie on the Toilet", attributes: [NHIEAttributes.Gross] });
                $scope.deckNeverHaveIEver.push({ body: "Stuck My Hand in Dirty Toilet Water", attributes: [NHIEAttributes.Gross] });
                $scope.deckNeverHaveIEver.push({ body: "Thrown Up from Over-Eating", attributes: [NHIEAttributes.Gross] });
                $scope.deckNeverHaveIEver.push({ body: "Peed in a Pool", attributes: [NHIEAttributes.Gross] });

                // EMBARASSING AND GROSS
                $scope.deckNeverHaveIEver.push({ body: "Thrown Up on an Amusement Ride", attributes: [NHIEAttributes.Gross, NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Thrown Up on an Date", attributes: [NHIEAttributes.Gross, NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Been Attracted to a Relative", attributes: [NHIEAttributes.Gross, NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Peed My Pants After the Age of 16", attributes: [NHIEAttributes.Gross, NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Gone a Week Without Showering", attributes: [NHIEAttributes.Gross, NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Peed in my Pants in Public", attributes: [NHIEAttributes.Embarrassing, NHIEAttributes.Gross] });

                // EMBARASSING
                $scope.deckNeverHaveIEver.push({ body: "Cheated on Someone", attributes: [NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Walked in on my Parents Having Sex", attributes: [NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Been Fired", attributes: [NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Passed out in the Bathroom", attributes: [NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Cried During Sex", attributes: [NHIEAttributes.Embarrassing] });
                $scope.deckNeverHaveIEver.push({ body: "Been Locked in a Car", attributes: [NHIEAttributes.Embarrassing] });

                // TROUBLED YOUTH AND EMBARASSING
                $scope.deckNeverHaveIEver.push({ body: "Cheated on a Test", attributes: [NHIEAttributes.Embarrassing, NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Been Suspended from School", attributes: [NHIEAttributes.Embarrassing, NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Failed a Major Test", attributes: [NHIEAttributes.Embarrassing, NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Failed a Class", attributes: [NHIEAttributes.Embarrassing, NHIEAttributes.TroubledYouth] });

                // TROUBLED YOUTH
                $scope.deckNeverHaveIEver.push({ body: "Got Detention", attributes: [NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Prank Called Someone", attributes: [NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Smoked in the Bathroom", attributes: [NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Egged a House", attributes: [NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Toilet-Papered a House", attributes: [NHIEAttributes.TroubledYouth] });
                $scope.deckNeverHaveIEver.push({ body: "Skipped School", attributes: [NHIEAttributes.TroubledYouth] });

                // LUCKY
                $scope.deckNeverHaveIEver.push({ body: "Won Something On The Radio", attributes: [NHIEAttributes.Lucky] });
                $scope.deckNeverHaveIEver.push({ body: "Won The Lottery", attributes: [NHIEAttributes.Lucky] });
                $scope.deckNeverHaveIEver.push({ body: "Been to a Super Bowl", attributes: [NHIEAttributes.Lucky] });
                $scope.deckNeverHaveIEver.push({ body: "Been to a World Series Game", attributes: [NHIEAttributes.Lucky] });
                $scope.deckNeverHaveIEver.push({ body: "Touched a Penguin", attributes: [NHIEAttributes.Lucky] });

                // LUCKY AND CELEBRITY
                $scope.deckNeverHaveIEver.push({ body: "Been on the Radio", attributes: [NHIEAttributes.Celebrity, NHIEAttributes.Lucky] });
                $scope.deckNeverHaveIEver.push({ body: "Been in a Major Release Movie", attributes: [NHIEAttributes.Celebrity, NHIEAttributes.Lucky] });
                $scope.deckNeverHaveIEver.push({ body: "Kissed Someone Famous", attributes: [NHIEAttributes.Celebrity, NHIEAttributes.Lucky] });

                // CELEBRITY
                $scope.deckNeverHaveIEver.push({ body: "Played on a College Sport Team", attributes: [NHIEAttributes.Celebrity] });
                $scope.deckNeverHaveIEver.push({ body: "Been on TV", attributes: [NHIEAttributes.Celebrity] });
                $scope.deckNeverHaveIEver.push({ body: "Played on a Professional Sport Team", attributes: [NHIEAttributes.Celebrity] });
                $scope.deckNeverHaveIEver.push({ body: "Published Music Online or on an Album", attributes: [NHIEAttributes.Celebrity] });
                $scope.deckNeverHaveIEver.push({ body: "Been in a Student Film", attributes: [NHIEAttributes.Celebrity] });


                break;
        }
    }
    $scope.ShuffleNHIEs = function () {
        for (var i = 0; i < $scope.deckNeverHaveIEver.length; i++) {
            var cardToMove = $scope.deckNeverHaveIEver[i];
            var randomNumber = Math.floor(Math.random() * $scope.deckNeverHaveIEver.length);
            $scope.deckNeverHaveIEver[i] = $scope.deckNeverHaveIEver[randomNumber];
            $scope.deckNeverHaveIEver[randomNumber] = cardToMove;
        }
    }
    $scope.range = function(min, max, step) {
        step = step || 1;
        var input = [];
        if (max > min) {
            for (var i = min; i <= max; i += step) {
                input.push(i);
            }
        } else {
            for (var i = min; i >= max; i -= step) {
                input.push(i);
            }
        }
        return input;
    };

    // SETTINGS
    $scope.LoadSettings = function () {
        if (typeof (window.localStorage) != 'undefined') {
            // NEEDS TO BE PROGRAMMED

            $scope.settings_scoresToWin = window.localStorage.getItem("settings_scoresToWin");
            if ($scope.settings_scoresToWin == null) {
                $scope.settings_scoresToWin = true;
                window.localStorage.setItem("settings_scoresToWin", true);
            } else {
                if ($scope.settings_scoresToWin == "true") {
                    $scope.settings_scoresToWin = true;
                } else {
                    $scope.settings_scoresToWin = false;
                }
            }

        }
    }
    $scope.setupSettingsPage = function () {
        if (typeof (window.localStorage) != 'undefined') {
            //settingsUnlimited.setChecked($scope.settings_unlimited);
        } else {
            //settingsUnlimited.setChecked(false);
        }
    }
    $scope.explainTriviaCards = function () {
        // NEEDS TO BE PROGRAMMED
        navigator.notification.alert(
            'Trivia Cards randomly appear and challenge the drawer to a trivia question. Answer correctly and choose someone to drink. Otherwise, you drink twice.',  // message
            null,                       // callback
            'What are trivia cards?',     // title
            'Okay'                      // buttonName
        );
        analyticsTrackEvent("Help", "Explain Trivia Cards", "");
    }
    $scope.changeGameLength = function (newGameLength) {
        $scope.GameLength = String(newGameLength);
        window.localStorage.setItem("settings_gamelength", $scope.GameLength);
        RecordMilestone("Changed Language", $scope.AppLanguage);
    }
    $scope.changeFont = function (newFont) {
        $scope.settings_fontChooser = String(newFont);
        window.localStorage.setItem("settings_fontChooser", $scope.GameLength);
        $("#cardText").removeClass("dc-livinghell");
        $("#cardText").removeClass("dc-gooddog");
        $("#cardText").removeClass("dc-hurryup");
        $("#cardText").removeClass("dc-arial");
        switch (newFont) {
            case "1":
                $("#cardText").addClass("dc-hurryup");
                break;
            case "2":
                $("#cardText").addClass("dc-livinghell");
                break;
            case "3":
                $("#cardText").addClass("dc-gooddog");
                break;
            default:
                $("#cardText").addClass("dc-arial");
                break;
        }
    }
    $scope.changeLanguage = function (newLang) {
        $scope.AppLanguage = parseInt(newLang);
        $scope.BuildTranslations($scope.AppLanguage);
        window.localStorage.setItem("settings_language", $scope.AppLanguage);
        $scope.RecordMilestone("Changed Language");
        $scope.ResetGame();
    }
    $scope.showConfirm_startOver = function () {
        navigator.notification.confirm(
            $scope.translations['confirm-start-over'], // message
            $scope.onConfirm_startOver,     // callback to invoke with index of button pressed
            $scope.translations['start-over-question'],            // title
            [$scope.translations['yes'], $scope.translations['no']]             // buttonLabels
        );
    }
    $scope.onConfirm_startOver = function (buttonIndex) {
        if (buttonIndex == 1) {
            $scope.ResetGame();
            app.navi.popPage();
        }
    }
    $scope.sendMessage = function () {
        sendMessage($("#message_email").val(), $("#message_body").val(), "#contact-loading");
    }
    $scope.showConfirm_RemovePlayer = function () {
        navigator.notification.confirm(
            $scope.translations['confirm-message-remove-player'], // message
            $scope.onConfirm_RemovePlayer,     // callback to invoke with index of button pressed
            $scope.translations['remove-player'],            // title
            [$scope.translations['yes'], $scope.translations['no']]             // buttonLabels
        );
    }
    $scope.onConfirm_RemovePlayer = function (buttonIndex) {
        if (buttonIndex == 1) {
            $scope.RemovePlayer();
        }
    }


    // GAME PLAY
    $scope.PlayerHasScored = function (player) {
        if (player.score.indexOf($scope.deckPointer) > -1) {
            return true;
        } else {
            return false;
        }
    }
    $scope.TogglePlayerSelection = function (player) {
        if ($scope.deckPointer > -1) {
            if (player.score.indexOf($scope.deckPointer) > -1) {
                player.score.splice(player.score.indexOf($scope.deckPointer), 1);
            } else {
                player.score.push($scope.deckPointer);
            }
        } else {
            $scope.editPlayerIndex = $scope.playerList.indexOf(player);
            $scope.goToEditPlayer();
        }
    }
    $scope.ShowNextNHIE = function () {
        if ($scope.playerList.length == 0) {
            SimpleAlert("You Can't Play With Yourself", "Never Have I Ever is a party game. Gather some friends and add their names and pictures using the Add Player icon.");
        } else {
            if ($scope.IsGameOver()) {
                $scope.EndGame();
            } else {
                $scope.deckPointer++;
                var drawnNHIE = $scope.deckNeverHaveIEver[$scope.deckPointer];
                $scope.translations['card-text'] = drawnNHIE.body;
                BounceLikeJelly("#cardText");
                TempDisable("btnShowNext", 700);
                var htmlElem = document.getElementById("btnShowPrevious");
                if ($scope.deckPointer > 0) {
                    htmlElem.disabled = false;
                    htmlElem.className = "";
                } else {
                    htmlElem.disabled = true;
                    htmlElem.className = "hidden-button";
                }
            }
        }
    }
    $scope.ShowPreviousNHIE = function () {
        if ($scope.IsGameOver()) {
            $scope.EndGame();
        } else {
            $scope.deckPointer--;
            var drawnNHIE = $scope.deckNeverHaveIEver[$scope.deckPointer];
            $scope.translations['card-text'] = drawnNHIE.body;
            BounceLikeJelly("#cardText");
            if ($scope.deckPointer < 1) {
                var htmlElem = document.getElementById("btnShowPrevious");
                htmlElem.disabled = true;
                htmlElem.className = "hidden-button";
            } else {
                TempDisable("btnShowPrevious", 700);
            }
        }
    }
    $scope.AddPlayer = function () {
        var playername = $("#newPlayerName").val();
        var playerimg = $scope.newPlayerImg;
        if (playername == "" || playername == undefined) {
            SimpleAlert("What's Your Name?", "You need to enter a name for each player to keep score.");
        } else if ($scope.userWarning_noimage == false && (playerimg == "" || playerimg == undefined)) {
            SimpleAlert("Don't Forget Your Picture", "Click the camera icon to add a picture of each player. This will make scoring easier. Or, don't. Whatever.");
            $scope.userWarning_noimage = true;
        } else {
            if (playerimg == "" || playerimg == undefined) {
                playerimg = "images/blank-face.jpg";
            }
            if($scope.editPlayerIndex > -1) {
                // edit player
                $scope.playerList[$scope.editPlayerIndex] = {
                    name: playername,
                    img: playerimg,
                    score: []
                };
            } else {
                // add player
                $scope.playerList.push({
                    name: playername,
                    img: playerimg,
                    score: []
                });
            }
            $scope.newPlayerImg = "";
            app.navi.popPage();
            if($scope.playerList.length > 6) {
                $("#playercards").addClass("biggroup");
            }
        }
    }
    $scope.RemovePlayer = function () {
        $scope.playerList.splice($scope.editPlayerIndex, 1);
        $scope.newPlayerImg = "";
        app.navi.popPage();
        $scope.$apply();
    }
    $scope.IsGameOver = function () {
        var GameIsOver = false;
        var maxPlayerMarks = 0;
        $scope.playerList.forEach(function (item, index) {
            if (item.score.length > maxPlayerMarks) {
                maxPlayerMarks = item.score.length;
            }
        });
        if (maxPlayerMarks >= $scope.GameLength) {
            GameIsOver = true;
        } else {
            GameIsOver = false;
        }
        if ($scope.deckPointer == ($scope.deckNeverHaveIEver.length - 1)) {
            GameIsOver = true;
        }
        return GameIsOver;
    }
    $scope.EndGame = function () {
        $scope.game_status = "gameover";
        $scope.translations['card-text'] = "";
        $("#cardText").hide();
        $('.display-card').animate({ height: '0px' }, 1000);
        TempDisable("btnStartNewGame", 1000);
        TempDisable("btnRateApp", 1000);
        $('#btnStartNewGame').show(1000);
        $('#btnRateApp').show(1000);
        setTimeout( function() {
            $scope.CreateAwards();
        }, 1000);
    }
    $scope.StartNewGame = function () {
        $('.display-card').animate({ height: '40%' }, 1000);
        setTimeout(function () {
            $scope.ResetGame();
        }, 1000);
    }
    $scope.ResetGame = function () {
        $scope.playerList.forEach(function (item, index) {
            item.score = [];
        });
        $scope.ShuffleNHIEs();
        $scope.deckPointer = -1;
        $scope.playerAwards = [];
        $scope.game_status = "active";
        document.getElementById("btnShowPrevious").className = "hidden-button";
        document.getElementById("btnShowPrevious").disabled = true;
        $scope.translations['card-text'] = $scope.translations['app-title'];
        $("#cardText").show();
        $scope.$apply();
    }
    $scope.RateApp = function () {
        rateThisGame();
    }
    $scope.SendGameToFriend = function () {
        SendGameToFriend($scope.translations['shareapp-longdesc'], $scope.translations['shareapp-shortdesc'], "http://playneverhaveiever.com");
    }
    $scope.launchMoreGames = function () {
        launchMoreGames();
    }
    $scope.CreateAward = function (awardTitle, awardAvatarImg, awardSlogan, winnerName, callbackIndex) {
        $scope.canvasDom = $("#myCanvas")[0];
        $scope.canvas = $scope.canvasDom.getContext("2d");
        $scope.htmlCanvas = document.getElementById('myCanvas');
        $("#myCanvas").show();

        var awardSquareSize = 800;



        var img = new Image();
        img.onload = function (e) {
            $scope.htmlCanvas.height = awardSquareSize;
            $scope.htmlCanvas.width = awardSquareSize;
            $scope.canvas.drawImage(img, 0, 0, awardSquareSize, awardSquareSize, 0, 0, awardSquareSize, awardSquareSize);
            $scope.CanvasFillWrapText($scope.canvas, awardTitle, (awardSquareSize / 2), 15, (awardSquareSize - 40), 90, "72px HurryUp", "center", "top", "white");
            $scope.CanvasFillWrapText($scope.canvas, awardSlogan, (awardSquareSize / 2), (awardSquareSize - 114), (awardSquareSize - 60), 50, "32px HurryUp", "center", "bottom", "white");
        }
        img.src = "images/bg-blue.jpg";

        var img2 = new Image();
        img2.onload = function (e) {
            var avatarSize = awardSquareSize - 320;
            if (img2.height > img2.width) {
                var minImgSide = img2.width;
                var cropTop = (img2.height - img2.width) / 2;
                $scope.canvas.drawImage(img2, 0, cropTop, minImgSide, minImgSide, 150, 120, avatarSize, avatarSize);
            } else {
                var minImgSide = img2.height;
                var cropLeft = (img2.width - img2.height) / 2;
                $scope.canvas.drawImage(img2, cropLeft, 0, minImgSide, minImgSide, 150, 120, avatarSize, avatarSize);
            }

            $scope.canvas.strokeStyle = '#add8e6';  // some color/style
            $scope.canvas.lineWidth = 4;         // thickness
            $scope.canvas.strokeRect(150, 120, avatarSize, avatarSize);

            var urlBoxSize = 48;
            $scope.canvas.fillStyle = "#000000";
            $scope.canvas.fillRect(0, awardSquareSize - urlBoxSize, awardSquareSize, urlBoxSize);
            $scope.CanvasFillWrapText($scope.canvas, "www. Play Never Have I Ever .com", (awardSquareSize / 2), (awardSquareSize - (urlBoxSize / 2)), awardSquareSize, urlBoxSize, "24px Arial", "center", "middle", "white");

            var awardimg = $scope.saveAwardPicture(awardTitle, winnerName, callbackIndex);
            $("#myCanvas").hide();

        }
        img2.src = awardAvatarImg;
    }
    $scope.CreateAwards = function () {
        $scope.playerAwards = [];
        $scope.awardsToMake = [];
        $scope.playersAwarded = [];

        switch ($scope.AppLanguage) {
            case LANGUAGE.SPANISH:
                break;
            default:
                $scope.playerList.forEach(function (player_item, player_index) {
                    player_item.attr_sexy = 0;
                    player_item.attr_illegal = 0;
                    player_item.attr_nerdy = 0;
                    player_item.attr_dangerous = 0;
                    player_item.attr_gross = 0;
                    player_item.attr_adventurous = 0;
                    player_item.attr_embarrassing = 0;
                    player_item.attr_smooth = 0;
                    player_item.attr_celebrity = 0;
                    player_item.attr_troubledyouth = 0;
                    player_item.attr_lucky = 0;
                    player_item.score.forEach(function (score_item, index) {
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Sexy) > -1) {
                            player_item.attr_sexy += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Illegal) > -1) {
                            player_item.attr_illegal += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Nerdy) > -1) {
                            player_item.attr_nerdy += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Dangerous) > -1) {
                            player_item.attr_dangerous += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Gross) > -1) {
                            player_item.attr_gross += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Adventurous) > -1) {
                            player_item.attr_adventurous += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Embarrassing) > -1) {
                            player_item.attr_embarrassing += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Smooth) > -1) {
                            player_item.attr_smooth += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Celebrity) > -1) {
                            player_item.attr_celebrity += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.TroubledYouth) > -1) {
                            player_item.attr_troubledyouth += 1;
                        }
                        if ($scope.deckNeverHaveIEver[score_item].attributes.indexOf(NHIEAttributes.Lucky) > -1) {
                            player_item.attr_lucky += 1;
                        }
                    });
                });

                var maxAttributes;

                $scope.AssembleAwards();

                // Loop through awards to make and use callbacks
                $scope.ProcessAwards(0);


                break;
        }

    }
    $scope.AssembleAwards = function () {

        // SEXY BEAST
        var winner_sexy = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_sexy > winner_sexy.maxTally) {
                    winner_sexy.winning_index = player_index;
                    winner_sexy.maxTally = player_item.attr_sexy;
                }
            }
        });
        if (winner_sexy.winning_index > -1) {
            $scope.playersAwarded.push(winner_sexy.winning_index);
            $scope.awardsToMake.push(["Sexy Beast", $scope.playerList[winner_sexy.winning_index].img, $scope.playerList[winner_sexy.winning_index].name + " practically wrote the book on love, or at least, definitely sexed it up a bit.", $scope.playerList[winner_sexy.winning_index].name]);
        }


        // SMOOTH CRIMINAL
        var winner_smooth = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_smooth > winner_smooth.maxTally) {
                    winner_smooth.winning_index = player_index;
                    winner_smooth.maxTally = player_item.attr_smooth;
                }
            }
        });
        if (winner_smooth.winning_index > -1) {
            $scope.playersAwarded.push(winner_smooth.winning_index);
            $scope.awardsToMake.push(["Smooth Criminal", $scope.playerList[winner_smooth.winning_index].img, "Let's be honest, " + $scope.playerList[winner_smooth.winning_index].name + " should probably be in jail. But there's no denying that charm.", $scope.playerList[winner_smooth.winning_index].name]);
        }


        // CAPTAIN ADVENTURE
        var winner_adventurous = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_adventurous > winner_adventurous.maxTally) {
                    winner_adventurous.winning_index = player_index;
                    winner_adventurous.maxTally = player_item.attr_adventurous;
                }
            }
        });
        if (winner_adventurous.winning_index > -1) {
            $scope.playersAwarded.push(winner_adventurous.winning_index);
            $scope.awardsToMake.push(["Captain Adventure", $scope.playerList[winner_adventurous.winning_index].img, "When there's thrills to be had, " + $scope.playerList[winner_adventurous.winning_index].name + " is first in line and ready for anything.", $scope.playerList[winner_adventurous.winning_index].name]);
        }



        // ILLEGAL
        var winner_illegal = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_illegal > winner_illegal.maxTally) {
                    winner_illegal.winning_index = player_index;
                    winner_illegal.maxTally = player_item.attr_illegal;
                }
            }
        });
        if (winner_illegal.winning_index > -1) {
            $scope.playersAwarded.push(winner_illegal.winning_index);
            $scope.awardsToMake.push(["The Outlaw", $scope.playerList[winner_illegal.winning_index].img, "It's clear that " + $scope.playerList[winner_illegal.winning_index].name + " has decided to live life on the other side of the tracks.", $scope.playerList[winner_illegal.winning_index].name]);
        }




        // NERDY
        var winner_nerdy = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_nerdy > winner_nerdy.maxTally) {
                    winner_nerdy.winning_index = player_index;
                    winner_nerdy.maxTally = player_item.attr_nerdy;
                }
            }
        });
        if (winner_nerdy.winning_index > -1) {
            $scope.playersAwarded.push(winner_nerdy.winning_index);
            $scope.awardsToMake.push(["Nerd!", $scope.playerList[winner_nerdy.winning_index].img, "By scientific calculation, it appears that " + $scope.playerList[winner_nerdy.winning_index].name + " is the nerdiest player.", $scope.playerList[winner_nerdy.winning_index].name]);
        }




        // DANGEROUS
        var winner_dangerous = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_dangerous > winner_dangerous.maxTally) {
                    winner_dangerous.winning_index = player_index;
                    winner_dangerous.maxTally = player_item.attr_dangerous;
                }
            }
        });
        if (winner_dangerous.winning_index > -1) {
            $scope.playersAwarded.push(winner_dangerous.winning_index);
            $scope.awardsToMake.push(["Dangerous", $scope.playerList[winner_dangerous.winning_index].img, "When it comes to risky business, " + $scope.playerList[winner_dangerous.winning_index].name + " laughs in the face of danger.", $scope.playerList[winner_dangerous.winning_index].name]);
        }




        // GROSS
        var winner_gross = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_gross > winner_gross.maxTally) {
                    winner_gross.winning_index = player_index;
                    winner_gross.maxTally = player_item.attr_gross;
                }
            }
        });
        if (winner_gross.winning_index > -1) {
            $scope.playersAwarded.push(winner_gross.winning_index);
            $scope.awardsToMake.push(["Josie Grossie", $scope.playerList[winner_gross.winning_index].img, "Take caution, you may want to wash your hands after touching " + $scope.playerList[winner_gross.winning_index].name, $scope.playerList[winner_gross.winning_index].name]);
        }





        // CELEBRITY
        var winner_celebrity = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_celebrity > winner_celebrity.maxTally) {
                    winner_celebrity.winning_index = player_index;
                    winner_celebrity.maxTally = player_item.attr_celebrity;
                }
            }
        });
        if (winner_celebrity.winning_index > -1) {
            $scope.playersAwarded.push(winner_celebrity.winning_index);
            $scope.awardsToMake.push(["Local Celebrity", $scope.playerList[winner_celebrity.winning_index].img, "Alert the paparazzi! " + $scope.playerList[winner_celebrity.winning_index].name + " is in the house.", $scope.playerList[winner_celebrity.winning_index].name]);
        }




        // TROUBLED YOUTH
        var winner_troubledyouth = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_troubledyouth > winner_troubledyouth.maxTally) {
                    winner_troubledyouth.winning_index = player_index;
                    winner_troubledyouth.maxTally = player_item.attr_troubledyouth;
                }
            }
        });
        if (winner_troubledyouth.winning_index > -1) {
            $scope.playersAwarded.push(winner_troubledyouth.winning_index);
            $scope.awardsToMake.push(["Troubled Youth", $scope.playerList[winner_troubledyouth.winning_index].img, "It's a hard knock life growing up on the mean streets, especially for trouble makers like " + $scope.playerList[winner_troubledyouth.winning_index].name, $scope.playerList[winner_troubledyouth.winning_index].name]);
        }




        // LUCKY
        var winner_lucky = { winning_index: -1, maxTally: 0 };
        $scope.playerList.forEach(function (player_item, player_index) {
            if ($scope.playersAwarded.indexOf(player_index) > -1) {
                // player already has an award, skip over them
            } else {
                if (player_item.attr_lucky > winner_lucky.maxTally) {
                    winner_lucky.winning_index = player_index;
                    winner_lucky.maxTally = player_item.attr_lucky;
                }
            }
        });
        if (winner_lucky.winning_index > -1) {
            $scope.playersAwarded.push(winner_lucky.winning_index);
            $scope.awardsToMake.push(["Lucky Duck", $scope.playerList[winner_lucky.winning_index].img, "Is it skill or just blind stupid luck that has given " + $scope.playerList[winner_lucky.winning_index].name + " such an amazing life?", $scope.playerList[winner_lucky.winning_index].name]);
        }
    }
    $scope.ProcessAwards = function (awardIndex) {
        if ($scope.awardsToMake.length > awardIndex) {
            setTimeout(function () {
                $scope.CreateAward($scope.awardsToMake[awardIndex][0], $scope.awardsToMake[awardIndex][1], $scope.awardsToMake[awardIndex][2], $scope.awardsToMake[awardIndex][3], awardIndex + 1);
            }, 500);
        } else {
            $scope.showAwards = true;
            $scope.$apply();
        }
    }
    $scope.saveAwardPicture = function (awardTitle, winnerName, callbackIndex) {
        window.canvas2ImagePlugin.saveImageDataToLibrary(
            function (msg) {
                $scope.playerAwards.push({ title: awardTitle, winner_name: winnerName, img: msg });
                $scope.ProcessAwards(callbackIndex);
            },
            function (err) {
                $scope.SimpleAlert("Error", err);
            },
            document.getElementById('myCanvas')
        );

        $scope.htmlCanvas.height = 1;
        $scope.htmlCanvas.width = 1;
    }
    $scope.CanvasFillWrapText = function (context, text, x, y, maxWidth, lineHeight, textfont, textalignment, textbaseline, textcolor) {
        context.font = textfont;
        context.textAlign = textalignment;
        context.textBaseline = textbaseline;
        context.fillStyle = textcolor;

        var words = text.split(' ');
        var line = '';

        for (var n = 0; n < words.length; n++) {
            var testLine = line + words[n] + ' ';
            var metrics = context.measureText(testLine);
            var testWidth = metrics.width;
            if (testWidth > maxWidth && n > 0) {
                context.fillText(line, x, y);
                line = words[n] + ' ';
                y += lineHeight;
            }
            else {
                line = testLine;
            }
        }
        context.fillText(line, x, y);
    }
    $scope.ShareAward = function(award) {
        ShareImage(award.img);
    }


    // NAVIGATION
    $scope.goToSettings = function () {
        analyticsTrackScreen("Settings");
        app.navi.pushPage('settings.html', { onTransitionEnd: $scope.setupSettingsPage });
    }
    $scope.goToAddNewPlayer = function () {
        $scope.editPlayerIndex = -1;
        $scope.newPlayerImg = "";
        $scope.translations['screen-title-add-player'] = $scope.translations['add-player'];
        app.navi.pushPage('addplayer.html');
    }
    $scope.goToEditPlayer = function () {
        if ($scope.editPlayerIndex > -1) {
            console.log("editing player " + $scope.editPlayerIndex);
            $scope.translations['screen-title-add-player'] = $scope.translations['edit-player'];
            app.navi.pushPage('addplayer.html', { onTransitionEnd: $scope.fillInPlayerInfo });
        } else {
            console.log("editPlayerIndex is -1");
        }
    }
    $scope.fillInPlayerInfo = function () {
        console.log("callback made");
        $("#newPlayerName").val($scope.playerList[$scope.editPlayerIndex].name);
        $scope.newPlayerImg = $scope.playerList[$scope.editPlayerIndex].img;
        $("#imgNewPlayer").css("background-image", "url(" + $scope.newPlayerImg + ")");
        $scope.$apply();
    }
    $scope.GoToPromoCodeRedemption = function () {
        analyticsTrackScreen("Promo Code Redemption");
        app.navi.pushPage('redeem-promo.html');
    }
    $scope.GoToContactUs = function () {
        analyticsTrackScreen("Contact Us");
        app.navi.pushPage('contact-us.html');
    }


    // HANDLE RESPONSES
    $scope.handlePromoResponse = function (resp) {
        if (resp.status == "success") {
            var instruction = resp.password;
            navigator.notification.alert(
                'Thanks for redeeming your promo code. You now have new game features!',  // message
                null,               // callback
                'New Features Unlocked!',     // title
                'Okay'              // buttonName
            );
            $scope.$apply(function () {
                window.localStorage.setItem("settings_upgraded", resp.password);
                $scope.settings_upgraded = resp.password;
            });
            app.navi.popPage();
            analyticsTrackEvent("Promotions", "Promo Code Applied", "");
        } else {
            navigator.notification.alert(
                'Uh oh! It looks like your promo code isn\'t valid. Check the code and try again. If the problem persists, contact us at games@digitsinmotion.com',  // message
                null,               // callback
                'Promo Code Not Valid',     // title
                'Okay'              // buttonName
            );
            analyticsTrackEvent("Promotions", "Promo Code Rejected", "");
        }
    }
    $scope.handleNHIEsUpdate = function (resp) {
        // NEEDS TO BE PROGRAMMED
        if (resp.status == "success") {
            activestarcard_name = resp.name;
            window.localStorage.setItem("activestarcard_name", resp.name);
            activestarcard_desc = resp.desc;
            window.localStorage.setItem("activestarcard_desc", resp.desc);
            activestarcard_img = resp.img;
            window.localStorage.setItem("activestarcard_img", resp.img);
            activestarcard_loaded = true;
        }
    }


    $scope.CapturePlayerPhoto = function() {
        // Retrieve image file location from specified source
        navigator.camera.getPicture($scope.onPhotoDataSuccess, $scope.onFail, {
            quality: 50,
            targetWidth: 800,
            targetHeight: 800,
            correctOrientation: true,
            destinationType: Camera.DestinationType.FILE_URI
        });
    }
    $scope.onPhotoDataSuccess = function (imageURI) {
        $scope.newPlayerImg = imageURI;
        $("#imgNewPlayer").css("background-image", "url(" + imageURI + ")");
        $scope.$apply();

    }
    $scope.onFail = function() {
        console.log("fail");
    }

});

