﻿// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
// ----------------------   DIGIMO SHARED FUNCTIONS   ----------------------
// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
// -------------------------------   v2   ----------------------------------
// -------------------------------------------------------------------------
// -------------------------------------------------------------------------


// REQUIRED PLUGINS:
// device
// notification
// https://github.com/gbenvenuti/cordova-plugin-screen-orientation.git
// https://github.com/floatinghotpot/cordova-admob-pro.git
// https://github.com/phonegap/phonegap-plugin-push.git
// https://github.com/phonegap-build/GAPlugin.git


// App Specific Variables
var thisAppVersion;
var thisVersionKey;
var AnalyticsTrackingID;
var thisAppName;
var thisAdmobID;
var thisAppID;
var thisIOSListing;
var thisWindowsStoreListing;
var thisGooglePlayListing;
var thisDefaultAppListing;
var app_debug;
var device_platform;
var device_model;
var device_uuid;
var device_name;
var AppPushNotificationsSenderID;
var AppNameForPushNotifications;
var promoCodes = [];
var authToken = "";//"cd267e50-318d-11e6-b0b4-e0db550e0060";
var userPKey = 0;
var settings_upgraded = "";

// Plugin Variables
var push;
var gaPlugin;
var GA_ENDPOINT = 'https://www.google-analytics.com/collect';
var cid;

// Enums
LANGUAGE = {
    ENGLISH: 1,
    GERMAN: 2,
    SPANISH: 3,
    CHINESETRADITIONAL: 4,
    CHINESESIMPLIFIED: 5
}

// Init Digimo Services to set up variables needed for various shared functions
LoadDigimoServices = function (_appName, _appVersion, _appDebug, _appVersionKey, _appTrackingCode, _appIdentifier, _appAdmobID, _appIOSListing, _appAndroidListing, _appWindowsListing, _appDefaultStoreListing, _lockToPortraitOrientation, _appPushNotificationsSender, _appNameForPushNotifications, _appPushNotificationCallBackFunction) {
    thisAppName = _appName;
    thisAppVersion = _appVersion;
    thisVersionKey = _appVersionKey;
    AnalyticsTrackingID = _appTrackingCode;
    thisAppID = _appIdentifier;
    thisAdmobID = _appAdmobID;
    thisIOSListing = _appIOSListing;
    thisGooglePlayListing = _appAndroidListing;
    thisWindowsStoreListing = _appWindowsListing;
    thisDefaultAppListing = _appDefaultStoreListing;
    app_debug = _appDebug;
    AppPushNotificationsSenderID = _appPushNotificationsSender;
    AppNameForPushNotifications = _appNameForPushNotifications;
    
    if (app_debug) {
        SimpleAlert("WARNING", "App is running in Debug Mode");
    } else {
        device_platform = device.platform;
        device_model = device.model;
        device_uuid = device.uuid;
        device_name = device.name;
        if (_lockToPortraitOrientation) {
            LockOrientation();
        }
        if (AnalyticsTrackingID != "" && AnalyticsTrackingID != null) {
            //LoadAnalytics()
        }
        if (thisAdmobID != "" && thisAdmobID != null) {
            LoadBannerAds();
        }
        
        if (AppPushNotificationsSenderID != "" && AppPushNotificationsSenderID != null) {
            InitPushDeviceRegistration(_appPushNotificationCallBackFunction);
        }

        //analyticsTrackEvent("General", "App Loaded", thisAppName);
    }

    
}

document.addEventListener("backbutton", onBackKeyDown, false);
function onBackKeyDown() {
    if (platformIsAndroidOrApple()) {
        app.navi.popPage();
    }
}

// Simple Alerts launched the Cordova notifications alert
// REQUIRED PLUGINS: notification
SimpleAlert = function (title, message) {
    if (!navigator.notification) {
        console.log(title, message);
    } else {
        navigator.notification.alert(
            message,  // message
            null,         // callback
            title,     // title
            'OK'        // buttonName
        );
    }
}


// Several plugins only support iOS and Android devices. This function returns a true if the user is using one of those devices.
// REQUIRED PLUGINS: device
platformIsAndroidOrApple = function () {
    if (device_platform == "iOS" || device_platform == "Android") {
        return true;
    } else {
        return false;
    }
}


// Locks the orientation to portrait mode
// REQUIRED PLUGINS: https://github.com/gbenvenuti/cordova-plugin-screen-orientation.git
LockOrientation = function () {
    if (typeof (screen) != 'undefined') {
        screen.lockOrientation('portrait');
    }
}


// Initializes Google AdMob
// REQUIRED PLUGINS: https://github.com/floatinghotpot/cordova-admob-pro.git
LoadBannerAds = function () {
    var admobid = {};
    // select the right Ad Id according to platform
    if (/(android)/i.test(navigator.userAgent)) {
        if (AdMob) AdMob.createBanner({
            adId: thisAdmobID,
            adSize: 'SMART_BANNER',
            overlap: false,
            position: AdMob.AD_POSITION.BOTTOM_CENTER,
            autoShow: true
        });
    } else if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
        if (AdMob) AdMob.createBanner({
            adId: thisAdmobID,
            adSize: 'SMART_BANNER',
            overlap: true,
            position: AdMob.AD_POSITION.BOTTOM_CENTER,
            autoShow: true
        });

    } else {
        if (AdMob) {
            AdMob.createBanner({
                adId: thisAdmobID,
                adSize: 'SMART_BANNER',
                overlap: true,
                position: AdMob.AD_POSITION.BOTTOM_CENTER,
                autoShow: true
            });
        }

        //// select the right Ad Id according to platform 
        //var div = document.createElement("div");
        //document.getElementById('appBody').appendChild(div);
        //var banner = new Smaato(div, {
        //    publisherId: "1100022247",
        //    adId: '130133117',
        //    position: SMAATO_AD_POSITION.BOTTOM_CENTER,
        //    adSize: SMAATO_AD_SIZE.BANNER,
        //    autoShow: true
        //});
    }
}


// Register the device for Push Notifications
// REQUIRED PLUGINS: https://github.com/phonegap/phonegap-plugin-push.git
InitPushDeviceRegistration = function (callbackNotification) {
    try {
        push = PushNotification.init({
            android: {
                senderID: AppPushNotificationsSenderID
            },
            ios: {
                alert: "true",
                badge: "true",
                sound: "true"
            },
            windows: {}
        });
    }
    catch (err) {
        //analyticsTrackEvent("Error", "Push Plugin Registration Failed", e.message);
        //SimpleAlert('CATCH ERROR', 'CATCH ERROR: ' + err.message);
    }

    push.on('registration', function (data) {
        RegisterPushDevice(data.registrationId);
    });
    push.on('notification', function (data) {
        var title = data.title;
        if (title == '' || title == null) { title = 'By the way...' }
        navigator.notification.alert(
            data.message,  // message
            null,         // callback
            title,     // title
            'Okay'        // buttonName
        );
        callbackFunction(data.title, data.message);
    });
    push.on('error', function (e) {
        //SimpleAlert('ERROR', "ERROR: " + e.message);
        //analyticsTrackEvent("Error", "Push Plugin Failed", e.message);
    });
}


// Register device push details to database
// PLUGINS REQUIRED: 
// REQUIRES: jQuery
RegisterPushDevice = function (RegistrationID) {
    //BEGIN AJAX TO REGISTER PUSH DEVICE
    var request;
    if (request) {
        request.abort();
    }
    var formData = { "key": thisVersionKey, "app":  AppNameForPushNotifications, "regid": RegistrationID, "uuid": device_uuid, "platform": device_platform, "appversion": thisAppVersion, "mod": device_model, "name": device_name };
    request = $.ajax
    ({
        url: "http://etc.digitsinmotion.com/registerpushdevice.php",
        type: "post",
        data: formData,
        dataType: 'json'
    });

    request.done(function (response, textStatus, jqXHR) {

    });
    request.fail(function (jqXHR, textStatus, errorThrown) {
        //analyticsTrackEvent("Error", "Push Registration Failed", textStatus);
    });
    request.always(function () {
    });
}

// Login with Facebook
// PLUGINS REQUIRED: https://github.com/Wizcorp/phonegap-facebook-plugin.git
// REQUIRES: jQuery
launchFacebookLogin = function (arrayOfPermissions, callbackFunction, fieldsNeeded) {
    var fbLoginSuccess = function (userData) {
        FBGetData(userData.authResponse.userID, arrayOfPermissions, callbackFunction, fieldsNeeded);
    }

    var fbLoginFailure = function (errorMsg) {
        if (errorMsg.errorCode == '4201') {
            SimpleAlert("Login Error", "There was an issue authenticating with Facebook. Please try again. If error persists, contact our team for assistance at apps@digitsinmotion.com");
        }
    }

    facebookConnectPlugin.login(arrayOfPermissions,
		fbLoginSuccess,
		fbLoginFailure
	);
}
FBGetData = function(userID, arrayOfPermissions, callbackFunction, fieldsNeeded) {
    facebookConnectPlugin.api(userID + "/?fields=" + fieldsNeeded, arrayOfPermissions,
		function (result) {
		    callbackFunction(userID, result);
		},
		function (error) {
		    SimpleAlert("Uh oh!", "There was an issue authenticating with Facebook. Please try again. If error persists, contact our team for assistance at apps@digitsinmotion.com");
		}
    );
}


// Decode HTML for Translations
// PLUGINS REQUIRED: 
decodeHTML = function (encoded) {
    var elem = document.createElement('textarea');
    elem.innerHTML = encoded;
    var decoded = elem.value;
    return decoded;
}

// Launch Digimo Games website
// PLUGINS REQUIRED: InAppBrowser
launchMoreGames = function () {
    //analyticsTrackEvent("Promotions", "More Games", "");
    window.open('http://apps.digitsinmotion.com', '_system');
    return false;
}

// Send Game to a Friend via Sharing Service
// PLUGINS REQUIRED: https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin.git
SendGameToFriend = function (shareAppLongDescription, shareAppShortDescription, shareAppWebsite) {
    // NEEDS TO BE PROGRAMMED
    //analyticsTrackEvent("Promotions", "Send Game To Friend", "");
    window.plugins.socialsharing.share(shareAppLongDescription, shareAppShortDescription, null, shareAppWebsite);
}


// Reward user for sharing game via Sharing Service
// PLUGINS REQUIRED: https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin.git
ShareToUnlockFeatures = function (shareToUnlockDescription, shareAppWebsite) {
    // NEEDS TO BE PROGRAMMED
    window.plugins.socialsharing.shareViaFacebook(shareToUnlockDescription, null, shareAppWebsite, ShareToUnlockFeatures_OnSuccess, function (errormsg) { /*analyticsTrackEvent("Error", "Shared For New Features", errormsg);*/ });
}
ShareToUnlockFeatures_OnSuccess = function () {
    // NEEDS TO BE PROGRAMMED
    SimpleAlert('New Features Unlocked!', 'Thanks for sharing ' + _appName + '. You now have new game features!');
    window.localStorage.setItem("settings_upgraded", 'vit4minDC');
    settings_upgraded = 'vit4minDC';
    app.navi.popPage();
    //analyticsTrackEvent("Promotions", "Shared For New Features", "");
}



// Share an image
// PLUGINS REQUIRED: https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin.git
ShareImage = function (ImageURL) {
    window.plugins.socialsharing.share(null, null, 'file:///' + ImageURL, null);
}


// Reward user for sharing game via Sharing Service
// REQUIRED: jQuery
checkPromoCode = function (promoCode, app, promoLoadingElement, handlePromoResponse) {
    var request;
    if (request) {
        request.abort();
    }
    $(promoLoadingElement).css("display", "block");
    //analyticsTrackEvent("Promotions", "Promo Code Submitted", promoCode);

    var formData = { "key": thisVersionKey, "platform": device_platform, "appversion": thisAppVersion, "pcode": promoCode, "app": _appNameForPushNotifications };
    request = $.ajax
    ({
        url: "http://etc.digitsinmotion.com/promo.php",
        type: "post",
        data: formData,
        dataType: 'json',
        success: handlePromoResponse
    });

    request.done(function (response, textStatus, jqXHR) {
    });

    request.fail(function (jqXHR, textStatus, errorThrown) {
        SimpleAlert('Uh Oh!', 'There was an error while confirming your promo code. Please try again or contact us directly at games@digitsinmotion.com');
        //analyticsTrackEvent("Error", "Promo Code Check Failure", errorThrown);

    });

    request.always(function () {
        $(promoLoadingElement).hide();
    });
}


// Keeps the screen on while using the app
// PLUGINS REQUIRED: https://github.com/EddyVerbruggen/Insomnia-PhoneGap-Plugin.git
KeepAwake = function () {
    if (window.plugins.insomnia) {
        window.plugins.insomnia.keepAwake();
    }
}


// Send users to the app store to rate the app
// PLUGINS REQUIRED: InAppBrowser
rateThisGame = function () {
    switch (device_platform) {
        case "windows":
        case "Win32NT":
            window.open(thisWindowsStoreListing, '_system');
            break;
        case "iOS":
            window.open(thisIOSListing, '_system');
            break;
        case "Android":
            window.open(thisGooglePlayListing, '_system');
            break;
        default:
            window.open(thisDefaultAppListing, '_system');
            break;
    }
}


// Send a message to Digits in Motion
// REQUIRED: jQuery
sendMessage = function (yourEmail, yourMessage, LoadingHtmlElement) {
    var request;
    if (request) {
        request.abort();
    }
    $(LoadingHtmlElement).show();

    var formData = { "key": thisVersionKey, "platform": device_platform, "appversion": thisAppVersion, "email": yourEmail, "message": yourMessage };
    request = $.ajax
    ({
        url: "http://etc.digitsinmotion.com/msg.php",
        type: "post",
        data: formData
    });

    request.done(function (response, textStatus, jqXHR) {
        SimpleAlert('Message Sent', 'Your message has been received. Thanks for contacting us!');
        //analyticsTrackEvent("Contact", "Message Sent", $("#message_email").val());
        app.navi.popPage();

    });

    request.fail(function (jqXHR, textStatus, errorThrown) {
        SimpleAlert('Uh Oh!', 'There was an error while sending your message. Please try again or contact us directly at games@digitsinmotion.com');
        //analyticsTrackEvent("Error", "Message Failure", errorThrown);

    });

    request.always(function () {
        $(LoadingHtmlElement).hide();
    });
}



// Load Google Analytics
// REQUIRED PLUGINS: device, https://github.com/phonegap-build/GAPlugin.git
LoadAnalytics = function () {
    if(!app_debug) {
        if (platformIsAndroidOrApple()) {
            gaPlugin = window.plugins.gaPlugin;
            if (typeof (gaPlugin) != 'undefined') {
                gaPlugin.init(null, null, AnalyticsTrackingID, 20);
            }
        } else {
            analyticsInitWP();
        }
    }
}
analyticsTrackScreen = function (screenTitle) {
    if (!app_debug) { 
        if (!promoCodes.indexOf("buM8l3BeeZ") >= 0) {
            if (platformIsAndroidOrApple()) {
                if (typeof (gaPlugin) != 'undefined') {
                    gaPlugin.trackPage(null, null, screenTitle);
                }
            } else {
                analyticsTrackScreenWP(screenTitle);
            }
        }
    }
}
analyticsTrackEvent = function (eventCategory, eventAction, eventLabel) {
    if (!app_debug) {
        if (!promoCodes.indexOf("buM8l3BeeZ") >= 0) {
            if (platformIsAndroidOrApple()) {
                if (typeof (gaPlugin) != 'undefined') {
                    gaPlugin.trackEvent(null, null, eventCategory, eventAction, eventLabel, 1);
                }
            } else {
                analyticsTrackEventWP(eventCategory, eventAction, eventLabel, 1);
            }
        }
    }
}
analyticsInitWP = function () {
    if (!app_debug) {
        cid = device.uuid; // cordova-plugin-device is required
        var xhr = new XMLHttpRequest();
        var body = 'v=1&t=pageview&tid=' + AnalyticsTrackingID + '&cid=' + cid + '&dp=%2Findex.html';
        xhr.open("POST", GA_ENDPOINT, true)
        xhr.onreadystatechange = function () {
            console.log('asd');
        }
        xhr.send(body);
    }
}
analyticsTrackEventWP = function (category, action, label, value) {
    if (!app_debug) {
        category = category && encodeURIComponent(category);
        action = action && encodeURIComponent(action);
        label = label && encodeURIComponent(label);
        value = value && encodeURIComponent(value);

        var xhr = new XMLHttpRequest();
        var body = 'v=1&t=event&tid=' + AnalyticsTrackingID + '&cid=' + cid + '&an=' + thisAppName + '&av=' + thisAppVersion + '&aid=' + thisAppID +
            '&ec=' + category + '&ea=' + action + '&el=' + label + (value ? '&ev=' + value : '');
        xhr.open("POST", GA_ENDPOINT, true);
        xhr.send(body);
    }
}
analyticsTrackScreenWP = function (screenTitle) {
    if (!app_debug) {
        screenTitle = screenTitle && encodeURIComponent(screenTitle);

        var xhr = new XMLHttpRequest();
        var body = 'v=1&t=screenview&tid=' + AnalyticsTrackingID + '&cid=' + cid + '&an=' + thisAppName + '&av=' + thisAppVersion + '&aid=' + thisAppID +
            '&cd=' + screenTitle;
        xhr.open("POST", GA_ENDPOINT, true);
        xhr.send(body);
    }
}


// Bounce.JS animations
// REQUIRED: Bounce.JS
function BounceLikeJelly(domElement) {
    var bounce = new Bounce();
    bounce.scale({
        from: { x: 0.5, y: 1 },
        to: { x: 1, y: 1 },
        easing: "bounce",
        duration: 1000,
        delay: 0,
        bounces: 4,
        stiffness: 1
    }).scale({
        from: { x: 1, y: 0.5 },
        to: { x: 1, y: 1 },
        easing: "bounce",
        duration: 1000,
        delay: 0,
        bounces: 6,
        stiffness: 1
    });
    bounce.applyTo(document.querySelectorAll(domElement));
    return bounce;
}
function BounceUp(domElement) {
    var bounce = new Bounce();
    bounce.translate({
        from: { x: 0, y: 100 },
        to: { x: 0, y: 0 },
        easing: "bounce",
        duration: 1000,
        delay: 0,
        bounces: 4,
        stiffness: 5
    }).scale({
        from: { x: 1, y: 1 },
        to: { x: 0.5, y: 0.5 },
        easing: "sway",
        duration: 500,
        delay: 0,
        bounces: 4,
        stiffness: 5
    });
    bounce.applyTo(document.querySelectorAll(domElement));
    return bounce;
}
function BounceCleanUp(bounceVar) {
    bounceVar.remove();
}


// Temporarily disable a button after clicking it
TempDisable = function(htmlElement, disableLength) {
    var htmlElem = document.getElementById(htmlElement);
    htmlElem.disabled = true;
    if (disableLength > 0) {
        setTimeout(function () {
            htmlElem.disabled = false;
        }, disableLength);
    }
}


// Record milestones for the app to use for push notifications
RecordMilestone = function (milestoneName, milestoneLanguage) {
    if(!app_debug) {
        var request;
        if (request) {
            request.abort();
        }
        var formData = { "key": thisVersionKey, "milename": milestoneName, "regid": RegID, "appname": thisAppID, "devuuid": device_uuid, "platform": device_platform, "appver": thisAppVersion, "devmodel": device_model, "devname": device_name, "lang": milestoneLanguage };
        request = $.ajax
        ({
            url: "http://etc.digitsinmotion.com/cod_milestones.php",
            type: "post",
            data: formData,
            dataType: 'json'
        });

        request.done(function (response, textStatus, jqXHR) {

        });
        request.fail(function (jqXHR, textStatus, errorThrown) {
            //analyticsTrackEvent("Error", "Record Milestone Failed", textStatus);
        });
        request.always(function () {
        });
    }
}